<template>
  <div class="flex flex-col rounded-lg bg-background5 m-profile-lang-seletion">
    <el-collapse v-model="activeCollapse">
      <el-collapse-item name="language">
        <template #title>
          <div class="flex justify-between w-full items-center px-6">
            <span class="fc-text4 opacity-50 text-sm">{{
              $t("language")
            }}</span>
            <div class="flex gap-2 items-center">
              <img
                class="w-4 h-4 border border-[var(--border)] rounded-full"
                :src="
                  getAssetImage(
                    `assets/materials/flagCircle/${defaultLanguage}.svg`
                  )
                "
                alt="Current Language"
              />
              <span class="fc-text4 text-sm font-normal">{{
                languageShortCodeForDisplay
              }}</span>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon
                  icon="angle-down"
                  class="m-language-collapse"
                />
              </div>
            </div>
          </div>
        </template>
        <a
          v-for="(lang, index) in languageSetting"
          :id="`lang-${lang.ISO}`"
          :key="index"
          class="flex items-center fc-text px-6 py-4 profile-lang-item"
          :class="{ activeLang: defaultLanguage === lang.ISO }"
          @click.prevent="switchLanguage(lang.ISO)"
        >
          <div class="flex items-center justify-center flex-shrink-0">
            <img
              class="w-4 h-4 border border-[var(--border)] rounded-full"
              :src="
                getAssetImage(`assets/materials/flagCircle/${lang.ISO}.svg`)
              "
              alt="Current Language"
            />
          </div>
          <div class="lang-menu-title w-full pl-6">
            {{ lang.LanguageLocalName }}
          </div>
          <IconTick
            v-if="defaultLanguage === lang.ISO"
            class="w-5 h-5 flex-shrink-0 tc-primary tick-icon"
          />
        </a>
      </el-collapse-item>
    </el-collapse>
  </div>
</template>

<script setup lang="ts">
import IconTick from "~/assets/icons/tick.svg?component";
import { store } from "~~/store";

const emit = defineEmits<{
  (e: "expanded", lastEl: HTMLElement): void;
}>();

const activeCollapse = ref<string[]>([]);
const { getAssetImage } = commonHelper;

const {
  languageSetting,
  defaultLanguage,
  switchLanguage,
  languageShortCodeForDisplay,
} = useLanguageComponent();

watch(activeCollapse, (collapseItem) => {
  if (collapseItem.length) {
    const lastLang = languageSetting.value[languageSetting.value.length - 1];
    const el = document.getElementById(`lang-${lastLang?.ISO}`);
    if (!el) return;
    setTimeout(() => {
      emit("expanded", el);
    }, 17.25 * languageSetting.value.length);
  }
});
</script>

<style lang="scss">
.m-profile-lang-seletion {
  .el-collapse {
    --el-collapse-header-bg-color: transparent;
    --el-collapse-content-bg-color: transparent;
    border-top: 0;
    border-bottom: 0;
  }

  .lang-menu-title {
    font-family: Roboto;
    font-size: 14px;
    font-weight: 400;
    line-height: 16.41px;
    text-align: left;
    color: var(--text5);
  }

  .el-collapse-item__header {
    &.is-active {
      position: relative;

      &:after {
        content: "";
        position: absolute;
        left: 0;
        bottom: 0;
        width: 100%;
        height: 1px;
        background: var(--borderD500);
      }
    }
  }

  .flag-wrapper {
    width: 22px;
    height: 16px;
    border-radius: 2px;
    border: 1px solid var(--border);
    overflow: hidden;

    & > img {
      transform: scale(1.2);
    }
  }
}
</style>
